%{!?kernel_version: %{expand: %%define kernel_version %(uname -r|sed -e 's/EL.*$/EL/g')}}
%{!?kversionreltag: %{expand: %%define kversionreltag %(echo %{kernel_version} |sed -e 's/-/./g')}}
%{!?type: %{expand: %define type %(uname -r | sed -e 's/.*EL//g' | sed -e 's/^$/up/g')}}

# On RHEL 3, up type has no tag
%if "%{type}" != "up"
%define releasetag %{kversionreltag}.%{type}
%define kernel_dir %{kernel_version}%{type}
%else
%define releasetag %{kversionreltag}
%define kernel_dir %{kernel_version}
%endif

# Keep the modKey def identical to that in util.sh-PMWV.*
%define modKey 'PMWV|%{type}|vmmemctl'
%define vmwDB /usr/lib/vmware-tools/moduleScripts/vmmemctl/vmware-db.pl --os=linux,rhel,3
%define vmwPMWV /usr/lib/vmware-tools/moduleScripts/vmmemctl/vmware-pmwv.pl --os=linux,rhel,3 --release %{kernel_dir} --build 3917699 --modKey %{modKey}
%define kmp_version %version

Name:         vmware-tools-vmmemctl
BuildRequires: kernel-source gcc
Requires:     vmware-tools-vmmemctl-common
Requires:     vmware-tools-foundation >= 0:8.6.0
Provides:     vmware-tools-vmmemctl-kmp
Vendor:       VMware
License:      GPL
Group:        System/Kernel
Summary:      Contains the source needed to build the vmmemctl kernel module package (kmp) for the running kernel.
Epoch:        0
Version:      1.0.1.0
Release:      %{kversionreltag}.5.el3
BuildRoot:    %{_tmppath}/%{name}-%{version}-build


Source0:      vmmemctl.tar

%prep
%setup -n vmmemctl-only

%build
make clean
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
# The following command copies our newly build kernel module to a known
# location.  Unfortunately sometimes the kmod source build places the kmods
# in inconsistent locations.
if [ -e ../vmmemctl.o ]; then
   cp -v ../vmmemctl.o .
fi
if [ -e driver-%{kernel_dir}/vmmemctl-xxx-%{kernel_dir} ]; then
   cp -v driver-%{kernel_dir}/vmmemctl-xxx-%{kernel_dir} ./vmmemctl.o
fi

# Install kernel module
install -m 644 -D vmmemctl.o $RPM_BUILD_ROOT/lib/modules/%{kernel_dir}/extra/%{name}/vmmemctl.o

%package kmp-%{type}
Summary:      The vmmemctl kernel module built for the %{kernel_version} kernel.
Group:        System/Kernel
Requires:     vmware-tools-vmmemctl-common
Requires:     vmware-tools-foundation >= 0:8.6.0
Provides:     vmware-tools-vmmemctl-kmp
Release:      %{kversionreltag}.5.el3


%description
 This package enables you to build binary kernel module packages (kmps) for vmmemctl.  The vmmemctl module expands and contracts, allocating and freeing memory respectively within the guest OS. This causes the guest to invoke its memory management routines, allowing the ESX host to reclaim memory as memory pressure increases within the ESX host. Using this module allows for efficient memory over commitment on ESX hosts by forcing the guests to page out memory instead of forcing the host to page out memory.

%description kmp-%{type}
 This package contains a pre-compiled vmmemctl module for use with the %{kernel_version} kernel.   The vmmemctl module expands and contracts, allocating and freeing memory respectively within the guest OS. This causes the guest to invoke its memory management routines, allowing the ESX host to reclaim memory as memory pressure increases within the ESX host. Using this module allows for efficient memory over commitment on ESX hosts by forcing the guests to page out memory instead of forcing the host to page out memory.

%pre kmp-%{type}
# Deconfigure if upgrading
if [ $1 -gt 1 ]; then
   # If the type matches, stop the init script
   kmodType=`uname -r | sed -e 's/.*EL//g'`
   if [ -z "$kmodType" ]; then
      kmodType=up
   fi
   if [ "$kmodType" = "%{type}" ]; then
      /etc/init.d/vmmemctl stop || true
   fi

   %{vmwPMWV} --rpmSection=Postun
fi

# Configure
%{vmwPMWV} --rpmSection=Pre

%post kmp-%{type}
# Invoke the PMWV Post Section
%{vmwPMWV} --rpmSection=Post --baseMod=/lib/modules/%{kernel_dir}/extra/%{name}/vmmemctl.o

# If the type matches, start the init script
kmodType=`uname -r | sed -e 's/.*EL//g'`
if [ -z "$kmodType" ]; then
   kmodType=up
fi
if [ "$kmodType" = "%{type}" ]; then
   /etc/init.d/vmmemctl start || true
fi

%preun kmp-%{type}
# Only deconfigure if we are erasing the package here... not if we are upgrading.
if [ $1 = 0 ]; then
   # If the type matches, stop the init script
   kmodType=`uname -r | sed -e 's/.*EL//g'`
   if [ -z "$kmodType" ]; then
      kmodType=up
   fi
   if [ "$kmodType" = "%{type}" ]; then
      /etc/init.d/vmmemctl stop || true
   fi
fi

%postun kmp-%{type}
# Only deconfigure if we are erasing the package here... not if we are upgrading.
if [ $1 = 0 ]; then
   %{vmwPMWV} --rpmSection=Postun
fi

%files kmp-%{type}
%defattr(-, root, root, -)
/lib/modules/%{kernel_dir}/extra/%{name}/vmmemctl.o
